#include <LiquidCrystal.h>
#include <Servo.h>
#include "pitches.h"
#include <SoftwareSerial.h>

#define LEDG 7
#define LEDR 8

SoftwareSerial mySerial(0, 1); 
const int rs = 12, en = 11, d4 = 5, d5 = 4, d6 = 3, d7 = 10;
LiquidCrystal lcd(rs, en, d4, d5, d6, d7);

int servoPin = 6;
Servo ServoMotor;

int notesArray[] = {NOTE_C5, NOTE_CS5, NOTE_D5, NOTE_DS5, NOTE_F5, NOTE_FS5, NOTE_G5, NOTE_GS5, NOTE_A6};
int duration = 50;
volatile byte state = HIGH;
volatile int note = NOTE_C5;

String password = "123";
String entered_password = "";
const int buttonPin = 2;

// pin este corect
void open_door(){
    lcd.clear();
    lcd.setCursor(0,0) ;
    lcd.print("Welcome");
    lcd.setCursor(0,1) ;
    lcd.print("Code Successful");

    ServoMotor.write(0); 
    delay(1000);
    ServoMotor.write(90); 
    delay(1000); 
    digitalWrite(LEDG, HIGH);
    tone(9, NOTE_C5, 600);
    delay(5000);
    ServoMotor.write(0);
    delay(1000);
    ServoMotor.detach();
    digitalWrite(LEDG, LOW);
}

// pin este gresit
void door_closed(){
    lcd.setCursor(0,1) ;
    lcd.print("Incorrect");
    digitalWrite(LEDR, HIGH);
    tone(9, NOTE_C4, 600);
    delay(1000);
    tone(9, NOTE_C4, 600);
    delay(1000);
    tone(9, NOTE_C4, 600);
    delay(5000);
    digitalWrite(LEDR, LOW);
}

void setup() {  
    Serial.begin(9600);
    mySerial.begin(9600);
    delay(5000);

    lcd.setCursor(0,0);
    lcd.begin(16, 2);

    ServoMotor.attach(servoPin); 
    
    lcd.print("Enter Pin:");
    lcd.setCursor(0,1) ;

    pinMode(LEDG, OUTPUT);
    pinMode(LEDR, OUTPUT);  
    pinMode(buttonPin, INPUT_PULLUP);
    Serial.begin(9600);
    attachInterrupt(digitalPinToInterrupt(buttonPin), button_ISR, CHANGE);

}

// intrerupere
void button_ISR(){
  lcd.clear();
  lcd.setCursor(0,0) ;
  lcd.print("Enter Pin: ");
  lcd.setCursor(0,1) ;
  entered_password = "";
 
}

void loop() {
    String pinCode = "";
    String code="";

    while (mySerial.available()){
        // citeste datele din nodemcu
        code = mySerial.readString();
        
        if(code == "*"){ // utilizatorul a terminat de scris pin-ul
            if(entered_password == password){
                open_door();
                code = "";               
            }else{
                code = "";
                door_closed();              
            }
        }else if(code == "#"){ //clear
            code = "";
            pinCode = "";
            entered_password = "";
            lcd.clear();
            lcd.print("Enter Pin:");
            lcd.setCursor(0,1) ;           
        }else if(code == "Z"){
           String tempPass = "";
           for(int i = 0; i < 3; i++){
              tempPass = tempPass + mySerial.readString();
           }
           password = tempPass;
        }
        pinCode += code;
        entered_password += code;
        
    }
  
    lcd.print(pinCode);
}