#include <ESP8266WiFi.h>
#include <Keypad.h>
#include <SoftwareSerial.h>
#include <String.h>


const byte n_rows = 4;
const byte n_cols = 4;

SoftwareSerial mySerial(3,1);
int port = 8888;
WiFiServer server(port);
String password_pin = "";


const char *ssid = "Mi A2 Lite";  
const char *password = "kristina25";
int count=0;

char keys[n_rows][n_cols] = {
  {'1','2','3','A'},
  {'4','5','6','B'},
  {'7','8','9','C'},
  {'*','0','#','D'}
};
 
byte colPins[n_rows] = {D3, D2, D1, D0};
byte rowPins[n_cols] = {D7, D6, D5, D4};
 
Keypad myKeypad = Keypad( makeKeymap(keys), rowPins, colPins, n_rows, n_cols); 
 
void setup(){
  Serial.begin(115200);
  mySerial.begin(9600);

  WiFi.mode(WIFI_STA);
  WiFi.begin(ssid, password);

  Serial.println("Connecting to Wifi");
  while (WiFi.status() != WL_CONNECTED) {   
  delay(500);
  Serial.print(".");
  delay(500);
  }

  Serial.println("");
  Serial.print("Connected to ");
  Serial.println(ssid);

  Serial.print("IP address: ");
  Serial.println(WiFi.localIP());  
  server.begin();
  Serial.print("Open Telnet and connect to IP:");
  Serial.print(WiFi.localIP());
  Serial.print(" on port ");
  Serial.println(port);
}
 
void loop(){
  char myKey = myKeypad.getKey();
  String recvPass = "";
  WiFiClient client = server.available();
  
  // trimite date catre Arduino
  if (myKey != NULL){
    mySerial.write(myKey);
  }
  
  if (client) {    
    while(client.connected()){      
      while(client.available()>0){
        recvPass = client.read();
        password_pin = password_pin + recvPass;
      }
    }
    client.stop();
    mySerial.write("Z");
    for(int i = 0; i < 3; i++){
       mySerial.write(password_pin[i]);
    }
  }
}